extends ../_docs-template

block vars
  - var activeLink = 'vue';
  - var title = 'Messages Vue Component | Framework7 Vue Documentation';

block docs-index

block content


  .docs-nav
    include ../_docs-menu-vue
  .docs-content
    .motion-docs-page-title
      h1 Messages Component
      script(src="/js/motion/messages.js")
      f7-motion-messages(motion)

    p Messages Vue component represents <a href="../docs/messages.html">Messages</a> component.

    h2 Messages Components
    p There are following components included:
    ul
      li `f7-messages` - main Messages container
      li `f7-message` - single message element
      li `f7-messages-title` - single messages title element

    h2 Messages Properties
    table.params-table
      thead
        tr
          th Prop
          th Type
          th Default
          th Description
      tbody
        tr
          th(colspan="4") &lt;f7-messages&gt; properties
        tr
          td init
          td boolean
          td true
          td Initializes Messages component
        //- tr
          td auto-layout
          td boolean
          td false
          td Enable Auto Layout to add all required additional classes automatically based on passed conditions
        tr
          td new-messages-first
          td boolean
          td false
          td Enable if you want to use new messages on top, instead of having them on bottom
        tr
          td scroll-messages
          td boolean
          td true
          td Enable/disable messages autoscrolling when adding new message
        tr
          td scroll-messages-on-edge
          td boolean
          td true
          td If enabled then messages autoscrolling will happen only when user is on top/bottom of the messages view
        tr
          td typing
          td boolean
          td false
          td Allows to display/toggle typing message indicator
        //- tr
          td messages
          td array
          td
          td Array with initial messages. Each message in array should be presented as object with <a href="../docs/messages.html#single-message-parameters">message parameters</a>. Pass messages here if you don't use single-message components. Otherwise leave all bindings and data rendering to Vue
        //- tr
          td
            | first-message-rule<br><br>
            | last-message-rule<br><br>
            | tail-message-rule<br><br>
            | same-name-message-rule<br><br>
            | same-header-message-rule<br><br>
            | same-footer-message-rule<br><br>
            | same-avatar-message-rule<br><br>
          td function(message, previousMessage, nextMessage)
          td
          td Functions that must return boolean `true` or `false` based on required condition depending on previous and next messages. In case of match then the appropriage class will be added to message:
            ul
              li message-first
              li message-last
              li message-tail
              li message-same-name
              li message-same-header
              li message-same-footer
              li message-same-avatar
        //- tr
          td custom-class-message-rule
          td function(message, previousMessage, nextMessage)
          td
          td Function that must return additional message classes as string, based on required condition depending on previous and next messages
        tr
          th(colspan="4") &lt;f7-message&gt; properties
        tr
          td type
          td string
          td sent
          td Message type: `sent` (default) or `received`
        tr
          td text
          td string
          td
          td Message text
        tr
          td avatar
          td string
          td
          td Message user's avatar URL
        tr
          td name
          td string
          td
          td Message user's name
        tr
          td image
          td string
          td
          td Message image URL
        tr
          td header
          td string
          td
          td Message header
        tr
          td footer
          td string
          td
          td Message footer
        tr
          td text-header
          td string
          td
          td Message text header
        tr
          td text-footer
          td string
          td
          td Message text footer
        tr
          td first
          td boolean
          td false
          td Defines that the message is first in the conversation
        tr
          td last
          td boolean
          td false
          td Defines that the message is last in the conversation
        tr
          td tail
          td boolean
          td false
          td Defines that the message has visual "tail". Usually last message in conversation
        tr
          td same-name
          td boolean
          td false
          td Defines that this message sender name is the same as on previous message
        tr
          td same-header
          td boolean
          td false
          td Defines that this message header text is the same as on previous message
        tr
          td same-footer
          td boolean
          td false
          td Defines that this message footer text is the same as on previous message
        tr
          td same-avatar
          td boolean
          td false
          td Defines that this message user's avatar URL is the same as on previous message

    h2 Messages Events
    table.events-table
      thead
        tr
          th Event
          th Description
      tbody
        tr
          th(colspan="2") &lt;f7-message&gt; events
        tr
          td click
          td Event will be triggered when user clicks on message bubble
        tr
          td click:name
          td Event will be triggered when user clicks on message user's name
        tr
          td click:text
          td Event will be triggered when user clicks on message text
        tr
          td click:avatar
          td Event will be triggered when user clicks on message user's avatar
        tr
          td click:header
          td Event will be triggered when user clicks on message header
        tr
          td click:footer
          td Event will be triggered when user clicks on message footer
        tr
          td click:bubble
          td Event will be triggered when user clicks on message bubble

    h2 Messages Slots
    p Single message Vue component (`<f7-message>`) has additional slots for custom elements:
    ul
      li `default` - element will be inserted as a child of `<div class="message-bubble">` element in the end
      li `start` - element will be inserted in the beginning and direct child of main message element `<div class="message">`
      li `end` - element will be inserted in the end and direct child of main message element `<div class="message">`
      li `content-start` - element will be inserted in the beginning and direct child of the `<div class="message-content">` element
      li `content-end` - element will be inserted in the end and direct child of the `<div class="message-content">` element
      li `bubble-start` - element will be inserted in the beginning and direct child of the `<div class="message-bubble">` element
      li `bubble-end` - element will be inserted in the end and direct child of the `<div class="message-bubble">` element. Same as `default` slot
    p The following slots can be used inside of single message instead of same props if you need to pass there more complext layout:
    ul
      li `header` - element will be inserted in message header
      li `footer` - element will be inserted in message footer
      li `text` - element will be inserted in message text
      li `name` - element will be inserted in message name
      li `image` - element will be inserted in message image (supposed to be an `<img>` element)
      li `text-header` - element will be inserted in message text header
      li `text-footer` - element will be inserted in message text footer
    :code(lang="html")
          <f7-message
            type="sent"
            text="Hello World"
            name="John Doe"
            avatar="path/to/image.jpg"
          >
            <div slot="start">Start</div>
            <div slot="end">End</div>
            <div slot="content-start">Content Start</div>
            <div slot="content-end">Content End</div>
            <div slot="bubble-start">Bubble Start</div>
            <div slot="bubble-end">Bubble End</div>
          </f7-message>

          <!-- Renders to: -->

          <div class="message message-sent">
            <div>Start</div>
            <div class="message-avatar" style="background-image: url(path/to/image.jpg);"></div>
            <div class="message-content">
              <div>Content Start</div>
              <div class="message-name">John Doe</div>
              <div class="message-bubble">
                <div>Bubble Start</div>
                <div class="message-text">Hello World</div>
                <div>Bubble End</div>
              </div>
              <div>Content End</div>
            </div>
            <div>End</div>
          </div>

    h2 Examples
    p Here is how the full example of Messages page where it can be used together with <a href="messagebar.html">Messagebar</a>:
    +examplePreview('vue', 'messages.vue', 'messages')
